
# coding: utf-8

# In[4]:

#Step 1: token request

from json import dumps, loads, load
import os,sys,time,datetime,getopt,csv
import requests,json
import pprint
from requests import Request, Session, get
from time import sleep
from collections import OrderedDict
from getpass import _raw_input as input
from getpass import getpass
from getpass import GetPassWarning
from time import sleep
import shutil


#
#
def timeNow():
    return str(datetime.datetime.strftime(datetime.datetime.now(), "%H:%M:%S") + "=== ")

#

_sleepTime = 2

requestUrl = "https://hosted.datascopeapi.reuters.com/RestApi/v1/Authentication/RequestToken"

requestHeaders={
    "Prefer":"respond-async",
    "Content-Type":"application/json"
    }

requestBody={
    "Credentials": {
    "Username": "",
    "Password": ""
  }
}

_instFilename = 'C:\\docs\\Bamfunds\\20170906\\instrs.cfg'
_jsonFileName = 'C:\\docs\\Bamfunds\\20170906\\RefDataRequestStarter.json'
_instList = []



r1 = requests.post(requestUrl, json=requestBody,headers=requestHeaders)

if r1.status_code == 200 :
    jsonResponse = json.loads(r1.text.encode('ascii', 'ignore'))
    token = jsonResponse["value"]
    print ('Authentication token (valid 24 hours):')
    print (token)
else:
    print ('Please replace myUserName and myPassword with valid credentials, then repeat the request')

print(timeNow() + 'Loading Instruments File:' + _instFilename)

_inFile = open(_instFilename, "r")
for line in _inFile:
    line = line[:-1]
    _instElement = line
    _instList.append(_instElement)
print('Loaded')
_inFile.close()

#for _inst in _instList:
#    print('Read instrument \''+_inst+'\'')

# In[5]:

#Step 2: send an on demand extraction request using the received token 

_jReqBody = {}
with open(_jsonFileName, "r") as filehandle:
    _jReqBody=load( filehandle, object_pairs_hook=OrderedDict )

for _inst in _instList:
    _jReqBody["ExtractionRequest"]["IdentifierList"]["InstrumentIdentifiers"].append( { "IdentifierType": "ChainRIC", "Identifier": _inst } )

print("ExtractionRequest PP: ")
pp = pprint.PrettyPrinter(indent=1)
pp.pprint(_jReqBody)

requestUrl='https://hosted.datascopeapi.reuters.com/RestApi/v1/Extractions/Extract'

requestHeaders={
    "Prefer":"respond-async",
    "Content-Type":"application/json",
    "Authorization": "token " + token
}

r2 = requests.post(requestUrl, json=_jReqBody,headers=requestHeaders)

#displaying the response status, and the location url to use to get the status of the extraction request
#initial response status (after approximately 30 seconds wait) will be 202
print ('Status code is: '+ str(r2.status_code))

print ("<<<DEBUG>>> r2.headers are: ");
for k, v in r2.headers.items():
    print(k, v)

print ("<<<DEBUG>>> r2.content is: ");
print(r2.content)

_resp = r2
#requests.get(requestUrl,headers=requestHeaders)

#when the status of the request is 200 the extraction is complete, we display the jobId and the extraction notes
print ('response status = ' + str(_resp.status_code))

if _resp.status_code == 200 :
    r3Json = json.loads(_resp.text.encode('ascii', 'ignore'))
    jobId = r3Json["JobId"]
    print ('jobId: ' + jobId + '\n')
    notes = r3Json["Notes"]
    print ('Extraction notes:\n' + notes[0])
else:
    if _resp.status_code != 202:
        message="Error: Status Code:" + str(_resp.status_code) + " Message:" + _resp.text
        raise Exception(message)

    print(timeNow() + "Request message accepted. Please wait...")

    # Get location URL from response message header
    _location = _resp.headers['Location']

    # Pooling loop to check request status every 2 sec.
    while True:
        _resp = get( _location, headers=requestHeaders)
        _pollstatus = int(_resp.status_code)

        if _pollstatus==200:
            print(timeNow() +  "Status: 200 (completed)")
            r3Json = json.loads(_resp.text.encode('ascii', 'ignore'))
            jobId = r3Json["JobId"]
            print ('jobId: ' + jobId + '\n')
            notes = r3Json["Notes"]
            print ('Extraction notes:\n' + notes[0])
            break
        else:
            print(timeNow() +  "Status:", _resp.headers['Status'])

        #wait 2 sec and re-request the status to check if it already completed
        sleep(_sleepTime)

    print(timeNow() + "Response message received")

# In[7]:

#Step 4: get the extraction results, using the receive jobId

#requestUrl = "https://hosted.datascopeapi.reuters.com/RestApi/v1/Extractions/RawExtractionResults" + "('" + jobId + "')" + "/$value"
requestUrl = "https://hosted.datascopeapi.reuters.com/RestApi/v1/Extractions/ExtractionResult" + "(ExtractionId='" + jobId + "')" 

requestHeaders={
    "Prefer":"respond-async",
    "Content-Type":"text/plain",
    "Accept-Encoding":"gzip",
    "Authorization": "token " + token
}

print("<<<BEFORE GET>>> "+timeNow())
# r4 = requests.get(requestUrl,headers=requestHeaders)
# print("<<<BEGIN OUTPUT>>>"+timeNow())
# print (r4.text)
# print("<<<END OUTPUT>>>"+timeNow())

#Step 5: save results on disk to be unzipped using 7zip archiver

r5 = requests.get(requestUrl, headers=requestHeaders, stream=True)

print (r5.text)

print("<<<BEGIN SAVE>>>"+timeNow())
with open('c:\\Temp\\histRef.gz', 'wb') as f:
        r5.raw.decode_content = False
        shutil.copyfileobj(r5.raw, f)      
print("<<<END SAVE>>>"+timeNow())



